#ifndef __CalcPaths_H__
#define __CalcPaths_H__

#include "Path.h"
#include "Dijkstra.h"
#include "Correspondence.h"
#include <map>
#include <vector>

class CalcPaths
{
   public:

      static void buildGraph
         (  const map< int, vector< CorrespondenceMatrix* > >& allCorrespondences,
            vector< vector< Node* > >& allNodes, float sigma_dist );


      static void calcPaths( vector< vector< Node* > >& allNodes,
            map< float, Path >& allPaths );

      static void calcPathsMod( vector< vector< Node* > >& allNodes,
            map< float, Path >& allPaths, 
            vector< int > boundingbox,
            ListOfPaths& initPaths );

      static void removePath( const Path& P,  
            vector< vector< Node* > >& allNodes );

      static Path extractPath( vector< vector< Node* > >& allNodes );

};

#endif
