#ifndef __DIJKSTRA_H__
#define __DIJKSTRA_H__

#include <vector>
#include <list>
#include <limits>
#include <stdlib.h>

using namespace std;

#define MAX_COST 1
//#define MIN_COST 1

class Node
{
   public:
      Node()
      {
         minCost = numeric_limits< float >::max();
         prevNode = NULL;
         visited = false;
      };

      float minCost;
      Node* prevNode;
      vector< Node* > childrenNodes;
      vector< float > childrenCosts;
      //vector< Node* > parentNodes;
      //vector< float > parentCosts;

      unsigned short label;
      int slice;
      int x;
      int y;

      bool visited;

      bool removeChild( int slice, int label )
      {
         for( unsigned int i = 0; i < childrenNodes.size(); i++ )
         {
            Node* N = childrenNodes[i];
            if( (N->slice == slice) && (N->label == label ) )
            {
               childrenNodes.erase( childrenNodes.begin() + i );
               childrenCosts.erase( childrenCosts.begin() + i );
               //cout << "erasing " << N->slice << "," << N->label << endl ;
               return true;
            }
         }

         return false;
      }

      void print() const
      {
          cout << slice << ", " 
               << label << ", " 
               << minCost << "(" 
               << x << "," 
               << y << ")" 
               << endl;
      }

      // bounding box: x_min, y_min, x_max, y_max
      bool withinBoundingBox( vector< int > bb )
      {
         if( ( bb[0] < x ) && ( bb[2] > x ) &&
               ( bb[1] < y ) && ( bb[3] > y ) )
            return true;
         
         return false;
      }
};

class Dijkstra
{
   private:

      Node* root;

   public:

      Dijkstra()
      { 
         //buildGraph();
      };

      Dijkstra( Node* R )
      { 
         root = R;
         //traverseGraph();
         //buildGraph();
      };

      void buildGraph()
      {
         int k = 0;
         root = new Node();
         root->label = k; k++; //(rand()%10)+1;
         root->minCost = 0;
         cout << root->label << endl;
         cout << root->minCost << endl;
         for( int i = 0; i < 2; i++ )
         {
            Node* C = new Node();
            C->label = k; k++;//(rand()%10)+1;
            root->childrenNodes.push_back( C );
            root->childrenCosts.push_back( (rand()%10)+1 );
            cout << C->label << ", " << root->childrenCosts[i] << endl;
         }
         for( unsigned int j = 0; j < root->childrenNodes.size(); j++ )
         {
            Node* cN = new Node();
            cN->label = k; k++;//(rand()%10)+1;

            for( unsigned int l = 0; l < 2; l++ )
            {
               Node* N = root->childrenNodes[l];
               N->childrenNodes.push_back( cN );
               N->childrenCosts.push_back( (rand()%10) + 1 );
               cout << cN->label << ", " << N->childrenCosts[0] << endl;
            }
         }

         cout << "traverse: " << endl ;
         traverseGraph( root );
      }

      void calculateLeastCostPath()
      {
         //cout << "path: " << endl;
         list< Node* > Q;
         Q.push_back( root );
         root->minCost = 0;
         while( Q.size() > 0 )
         {
            Node* N = *(Q.begin());//Q[0];
            //cout << "label: " << N->label << ", #child: " << N->childrenNodes.size()<< endl ;
            N->visited = false;
            Q.pop_front();
            for( unsigned int i = 0; i < N->childrenNodes.size(); i++ )
            {
               Node* childNode = N->childrenNodes[ i ];
               float childCost = N->childrenCosts[ i ];
               //cout << childNode->label << "," << childCost << endl ;
               if( childCost + N->minCost < childNode->minCost )
               {
                  childNode->minCost = childCost + N->minCost;
                  childNode->prevNode = N;
                  Q.push_back( childNode );
               }
            } // end for

         } // end while

         //cout << "traverse: " << endl ;
         //traverseGraph( root );
      }

      void traverseGraph( )
      {
         traverseGraph( root );
      }

      void traverseGraph( Node* N )
      {
         N->visited = true;
         //if( N->childrenNodes.size() > 0 )
         //   cout << endl << N->label << " visiting " ;
         for( unsigned int i = 0; i < N->childrenNodes.size(); i++ )
         {
            cout << N->label << " visiting " ;
            cout << N->childrenNodes[i]->label << "," 
                 << N->childrenCosts[i] << "," 
                 << N->childrenNodes[i]->minCost << "; \n";
            if( !N->childrenNodes[i]->visited )
               traverseGraph( N->childrenNodes[i] );
         }
         //cout << endl ;
      }

      void resetCosts( Node* N )
      {
         N->visited = true;
         N->minCost = numeric_limits< float >::max();
         //if( N->childrenNodes.size() > 0 )
         //   cout << endl << N->label << " visiting " ;
         for( unsigned int i = 0; i < N->childrenNodes.size(); i++ )
         {
            if( !N->childrenNodes[i]->visited )
               resetCosts( N->childrenNodes[i] );
         }
         //cout << endl ;
      }

};

#endif
