#ifndef __ITKVTKCONVERT_H__
#define __ITKVTKCONVERT_H__


#include "itkImage.h"

#include "vtkImageData.h"

typedef itk::Image< float, 2 > ImageType;
typedef itk::Image< float, 3 > ImageType3D;

typedef itk::Image< long, 2 > LongImageType;

class ItkVtkConvert 
{

   public:

      ItkVtkConvert();
      ~ItkVtkConvert();

      static ImageType::Pointer ConvertToItkImage
                                  ( vtkImageData *vtkImage );

      static ImageType3D::Pointer ConvertToItkImage3D
                                  ( vtkImageData *vtkImage );
      
      static vtkImageData *ConvertToVtkImage
                                  ( ImageType::Pointer itkImage );
};

#endif 
